[![Go Reference](https://pkg.go.dev/badge/px.dev/pxapi.svg)](https://pkg.go.dev/px.dev/pxapi)

## Pixie Go API

`px.dev/pxapi` is a API for interacting with Pixie, a no-instrumentation Kubernetes observability platform.

```
go get px.dev/pxapi
```

- [API Quick Start Documentation](https://docs.px.dev/using-pixie/api-quick-start/)
- [API Reference Docs](https://pkg.go.dev/px.dev/pxapi)

## Resources

- [Website](https://px.dev)
- [Documentation](https://docs.px.dev)
- [Community Slack](https://slackin.px.dev/)
- [Youtube](https://www.youtube.com/channel/UCOMCDRvBVNIS0lCyOmst7eg)

## Contributing

Do not open pull requests or file issues directly against this repository, they will be ignored.

Instead, please open pull requests and file issues against our primary repo [pixie-io/pixie](https://github.com/pixie-io/pixie/).

Please follow the same contributing guide you would follow for any other pull request made to [pixie-io/pixie](https://github.com/pixie-io/pixie/).

This repository is published from [pixie-io/pixie](https://github.com/pixie-io/pixie/) using [google/copybara](https://github.com/google/copybara).

## About Us

Pixie was started by a San Francisco based startup, Pixie Labs Inc. Our north star is to build a new generation of intelligent products which empower developers to engineer the future. We were acquired by New Relic in 2020.

[New Relic, Inc.](https://newrelic.com) open sourced Pixie in April 2021.

## License

The Pixie Go API is licensed under [Apache License, Version 2.0](LICENSE).
