#!/bin/bash -e

# Copyright 2018- The Pixie Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# SPDX-License-Identifier: Apache-2.0

script_dir="$(dirname "$0")"

# shellcheck source=./src/stirling/scripts/utils.sh
source src/stirling/scripts/utils.sh

if [ -z "$BUILD_WORKSPACE_DIRECTORY" ] && [ -z "$TEST_TMPDIR" ]; then
  # If the script was run in a stand-alone way, then build and set paths.
  stirling_wrapper=$(bazel_build //src/stirling/binaries:stirling_wrapper)
else
  # If the script was run through bazel, the locations are passed as arguments.
  stirling_wrapper=$1
fi

# Main test run.
src/stirling/scripts/kprobe_leak_test.sh "$stirling_wrapper"
